#ifndef CDB_H
#define CDB_H

#include <dos.h>
#include "CEntry.h"
#include "bool.h"

#define INDEX_ID              0
#define INDEX_SUBJECT_STR     "Index"
#define INDEX_TEXT_STR        "This is the index file for the entire \
database.\n"

#define MAIN_ID               1
#define MAIN_SUBJECT_STR      "Main Screen"
#define MAIN_TEXT_STR         "This is where you can add and remove stuff"

#define MAX_ENTRIES_PER_DAY   100
#define TEMP_FILE_NAME        "tmp.fil"

enum eFileType { FT_HEADER, FT_TEXT };

class CDb {
 public:
  CDb();
  ~CDb();

  bool entryExists( long Id );
  void getFileName( eFileType FileType, long Id, char *pszFileName );
  long addEntry( date date, time time, char *szSubject, char *szFileName );
  void writeEntry( CEntry & Entry, char *pszFileName = 0 );
  CEntry *getEntry( long Id );
  void getSubject(long Id, char *szSubject);
  void getSubject( long Id, char *szSubject, bool & HasLinks );

 private:
  void createIndex( void );
  void createMain( void );
  long convertToId( date );
  long getNewId( date date );
  void readHeader( long Id, CHeader & Header );
  void writeHeader( long Id, CHeader & Header );

};

#endif CDB_H
